<?php

	/******************************************
	//    
	//    PDF Analytics (WordPress)
	//    	
	******************************************/

	define( 'SPECIAL_SAUCE' , TRUE );

	include_once('config.php');
	
	$pdf_request	=	( strpos($_SERVER['REQUEST_URI'], '?') !== FALSE ) ? stristr($_SERVER['REQUEST_URI'], '?', TRUE) : $_SERVER['REQUEST_URI'];
	$pdf_request	=	str_replace(['..','./'], ['',''], $pdf_request);
	$pdf_url		=	PDFA_ROOT.$pdf_request;
	$pdf_path		=	dirname(dirname(dirname(dirname(__FILE__)))).$pdf_request;

	if ( file_exists($pdf_path) == FALSE || stripos( $_SERVER['REQUEST_URI'] , 'tracking.php' ) !== FALSE )
	{
		include_once('../../../index.php');
		exit;
	}

	$pdf_size		=	filesize($pdf_path);
	
	$cid			=	( isset($_COOKIE['_ga']) ) ? clean_cid($_COOKIE['_ga']) : microtime(TRUE);
	$gid			=	( isset($_COOKIE['_gid']) ) ? clean_cid($_COOKIE['_gid']) : FALSE;
	
	$user_agent		=	( isset($_SERVER['HTTP_USER_AGENT']) ) ? $_SERVER['HTTP_USER_AGENT'] : FALSE;
	$ip_address		=	( isset($_SERVER['REMOTE_ADDR']) ) ? $_SERVER['REMOTE_ADDR'] : FALSE;
	$referrer		=	( isset($_SERVER['HTTP_REFERER']) ) ? $_SERVER['HTTP_REFERER'] : FALSE;
	
	$utm_campaign	=	( isset($_REQUEST['utm_campaign']) ) ? $_REQUEST['utm_campaign'] : FALSE;
	$utm_source		=	( isset($_REQUEST['utm_source']) ) ? $_REQUEST['utm_source'] : FALSE;
	$utm_medium		=	( isset($_REQUEST['utm_medium']) ) ? $_REQUEST['utm_medium'] : FALSE;
	$utm_keyword	=	( isset($_REQUEST['utm_keyword']) ) ? $_REQUEST['utm_keyword'] : FALSE;
	$utm_content	=	( isset($_REQUEST['utm_content']) ) ? $_REQUEST['utm_content'] : FALSE;
	
	if ( $referrer !== FALSE && $referrer !== '' && stripos($referrer, '://') )
	{
		$parse_url	=	parse_url($referrer);
		$domain		=	$parse_url['host'];
		$query		=	$parse_url['query'];
		$dotdomain	=	'.'.$domain;
		
		if ( !empty($parse_url['query']) )
		{
			parse_str($parse_url['query'], $url_vars);
			
			if ( !empty($url_vars['q']) )
			{
				$utm_keyword = $url_vars['q'];
			}
		}
		
		if ( stripos($dotdomain, '.google.') )
		{
			if ( strpos($_SERVER['REQUEST_URI'], 'gclid') !== FALSE )
			{
				$utm_source = 'google';
				$utm_medium = 'cpc';
			}
			else
			{
				$utm_source = 'google';
				$utm_medium = 'organic';
			}
			$utm_keyword = ( get_keyword( 'q', $query) !== FALSE ) ? get_keyword( 'q', $query) : $utm_keyword;
		}
		elseif ( stripos($dotdomain, '.bing.') )
		{
			$utm_source = 'bing';
			$utm_medium = 'organic';
			$utm_keyword = ( get_keyword( 'q', $query) !== FALSE ) ? get_keyword( 'q', $query) : $utm_keyword;
		}
		elseif ( stripos($dotdomain, '.yandex.') )
		{
			$utm_source = 'yandex';
			$utm_medium = 'organic';
			$utm_keyword = ( get_keyword( 'text', $query) !== FALSE ) ? get_keyword( 'text', $query) : $utm_keyword;
		}
		elseif ( stripos($dotdomain, '.yahoo.') )
		{
			$utm_source = 'yahoo';
			$utm_medium = 'organic';
			$utm_keyword = ( get_keyword( 'p', $query) !== FALSE ) ? get_keyword( 'p', $query) : $utm_keyword;
		}
		elseif ( stripos($dotdomain, '.baidu.') )
		{
			$utm_source = 'baidu';
			$utm_medium = 'organic';
			$utm_keyword = ( get_keyword( 'wd', $query) !== FALSE ) ? get_keyword( 'wd', $query) : $utm_keyword;
		}
		elseif ( stripos($dotdomain, '.naver.') )
		{
			$utm_source = 'naver';
			$utm_medium = 'organic';
			$utm_keyword = ( get_keyword( 'query', $query) !== FALSE ) ? get_keyword( 'query', $query) : $utm_keyword;
		}
		elseif ( stripos($dotdomain, '.msn.') )
		{
			$utm_source = 'msn';
			$utm_medium = 'organic';
			$utm_keyword = ( get_keyword( 'q', $query) !== FALSE ) ? get_keyword( 'q', $query) : $utm_keyword;
		}
		
		if ( empty($utm_keyword) ) { $utm_keyword = '(not provided)'; }
	}

	header('Content-Type: application/pdf');
	header('HTTP/1.1 200 OK');
	header('Link: <'.$pdf_url.'>; rel="canonical"');

	$ga_vars		=	[
							'v'		=>	'1',
							't'		=>	'pageview',
							'dl'	=>	$pdf_url,
							'cid'	=>	$cid,
							'tid'	=>	PDFA_TRACKING_ID,
							'_gid'	=>	$gid,
							'ds'	=>	'web',
							'uip'	=>	$ip_address,
							'ua'	=>	$user_agent,
							'dr'	=>	$referrer,
							'cn'	=>	$utm_campaign,
							'cs'	=>	$utm_source,
							'cm'	=>	$utm_medium,
							'ck'	=>	$utm_keyword,
							'cc'	=>	$utm_content,
							'z'		=>	time().rand(1000,9999),
						];
	$ga_vars = array_filter($ga_vars);

	$ga_vars_url	=	http_build_query($ga_vars);
	
	print file_get_contents($pdf_path);

	$ch_ga			=	curl_init();
	curl_setopt($ch_ga, CURLOPT_URL, 'https://www.google-analytics.com/collect');
	curl_setopt($ch_ga, CURLOPT_POST, count($ga_vars));
	curl_setopt($ch_ga, CURLOPT_POSTFIELDS, $ga_vars_url);
	curl_setopt($ch_ga, CURLOPT_CONNECTTIMEOUT, 3); 
	curl_setopt($ch_ga, CURLOPT_TIMEOUT, 5);
	$result = curl_exec($ch_ga);
	curl_close($ch_ga);
	
	exit;
	
	function clean_cid( $var )
	{
		$ga_parts = explode('.', $var);
		$ga_id = $ga_parts[2].'.'.$ga_parts[3];
		return $ga_id;
	}
	
	function get_keyword( $param , $query )
	{
		if ( $query !== FALSE && strlen($query) >= 2 )
		{
			parse_str($query, $q_array);
			if ( $q_array[$param] !== FALSE )
			{
				return urldecode($q_array[$param]);
			}
		}
		return FALSE;
	}
	
?>